import Helpers from '../test_helper.js';
import ClassUtils from '../../modules/utils/class_utils.js';
import test from 'ava';

var car;
var utils;
var simple;

test.before(t => {
    car = new Helpers.Car();
    utils = new ClassUtils();
    simple = new Helpers.SimpleClass();
})

test.after('cleanup', t => {
})

test.beforeEach(t => {
    // clear utils
})

test('It should get inheeritance tree of subclass', t => {
    const inherit = utils.getInheritanceTree(car)
    t.is(
        JSON.stringify(
            inherit.map(i => {
                return i.constructor.name
            })
        ),
        JSON.stringify(["API", "Car"])
    )
})

test('Class with no inheritance should return only itself', t => {
    const inherit = utils.getInheritanceTree(simple)
    t.is(
        JSON.stringify(
            inherit.map(i => {
                return i.constructor.name
            })
        ),
        JSON.stringify(["SimpleClass"])
    )
})

